#!/usr/bin/env python
# _*_ coding: utf-8 _*_
# небольшая демка на тему pygame.PixelArray
import os, pygame
katalog = 'cosmos'
risunok = 'whirlpool.jpg'
pygame.init ()
xs=800
ys=500
screen = pygame.display.set_mode ((xs, ys))
# задаем размер окна
pygame.display.flip ()
# отрисовываем его на дисплее
def show (image):
	# процедура заливает окно ,белым цветом и в координаты 0,0 впечатывает
	# картинку, после чего ждет 1 секунду
    screen.fill ((255, 255, 255))
    # заливка цветом 
    screen.blit (image, (0, 0))
    # загрузка изображения
    pygame.display.flip ()
    pygame.time.wait(1000)

#-----------------------------------------------------------------

surface = pygame.image.load (os.path.join (katalog, risunok))
# Грузим изображение на поверхность
ar = pygame.PixelArray (surface)
# Создаем 2-мерный массив ar соответствующий поверхности 
ar[::16,:] = [0,255,0] # вертик  зеленые полосы Y
ar[:,::16 ] = [0,255,0] # гориз зеленые полосы X
for i in range (ys):
 ar[i,i] = [0,0,255] # проводим красную диагональ
del ar
show (surface)

#-----------------------------------------------------------------

# заливка синим цветом
surface = pygame.image.load (os.path.join (katalog, risunok))
# грузим рисунок на поверхность
ar = pygame.PixelArray (surface)
# Создаем 2-мерный массив ar соответствующий поверхности 
ar[:,:] = [255,0,0]
# Во все точки массива записываем синий
del ar
show (surface)

#------------------------------------------------------------------

# Загрузить изображение и уменьшить его

surface = pygame.image.load (os.path.join (katalog, risunok))
# грузим рисунок на поверхность
ar = pygame.PixelArray (surface)
# Создаем 2-мерный массив ar соответствующий поверхности
del ar
show (surface)
 
for n in range (1,3): 
 # цикл n= 1, 2, 3
 ar = pygame.PixelArray (surface)
 # Создаем 2-мерный массив ar соответствующий поверхности
 pygame.time.wait(500)
 # Пауза 0,5 секунды
 surface = ar[::2,::2].make_surface ()
 # Создаем поверхность из каждой второй точки массива(уменьшаем в 2 раза)
 del ar
 screen.fill ((0, 0, 0))
 # заливаем экран черным цветом
 screen.blit (surface, (xs//2-xs//2//(n+1) ,ys//2-ys//2//(n+1)))
 # отрисовываем поверхность на экране
 pygame.display.flip ()
 # отображаем экран на дисплее
 
#-----------------------------------------------------------------

# Расходящиеся по X шторки
surface = pygame.image.load (os.path.join (katalog, risunok))
# грузим изображение на поверхность
ar = pygame.PixelArray (surface)
# Создаем 2-мерный массив ar соответствующий поверхности

sf1 = ar[:xs//2,:].make_surface ()
# Создаем поверхность где  x=0 до x=xs//2
# Левая шторка
sf2 = ar[xs//2:,:].make_surface ()
# Создаем поверхность где  x=xs//2 до xs 
# Правая шторка
del ar
for i in range (0,xs//2,10):

    screen.fill ((0, 0, 0))
    # заливка черным цветом
    screen.blit (sf1, (-i, 0))
    # левая шторка печатается на пиксел влево
    screen.blit (sf2, ((xs//2)+i, 0))
    # правая шторка печатается на пиксел вправо
    pygame.display.flip ()
    # отрисовка на дисплее
 
screen.fill ((0, 0, 0))
pygame.display.flip ()  
# закрашиваем экран черным цветом

#-----------------------------------------------------------------

# Сходящиеся по X к центру шторки
surface = pygame.image.load (os.path.join (katalog, risunok))
for i in range (0,xs//2,10):  
 ar = pygame.PixelArray (surface)
 sf1 = ar[:xs//2-i ,:].make_surface ()
 # левая шторка от 0 до xs//2-i, ширина уменьшается в цикле 
 sf2 = ar[xs//2+i: ,:].make_surface ()
 # правая шторка от xs//2+i до xs , ширина уменьшается в цикле
 del ar
 screen.fill ((0, 0, 0))
 # заливаем черным
 screen.blit (sf1, (i, 0))
 # левую шторку смещаем вправо в цикле
 screen.blit (sf2, (xs//2, 0))
 # правую шторку печатаем посередине
 
 pygame.display.flip ()
 # отрисовка на дисплее
screen.fill ((0, 0, 0))
# заливаем черным
pygame.display.flip () 
# отрисовка на дисплее

#----------------------------------------------------------------

# скроллинг вправо,влево,вниз,вверх

# скроллинг вправо
surface = pygame.image.load (os.path.join (katalog, risunok))
# грузим картинку
for i in range (0,xs+10,10):

 screen.fill ((0, 0, 0))
 # заливаем экран черным
 
 screen.blit (surface, (i, 0))
 # впечатываем картинку в экран со смещением в цикле на 10 вправо 
 pygame.display.flip ()
 # отрисовка на дисплее
 #----------------------------
 
 # скроллинг влево
surface = pygame.image.load (os.path.join (katalog, risunok))
 # грузим картинку
for i in range (0,xs+10,10):
 
 screen.fill ((0, 0, 0))
 # заливаем экран черным
 screen.blit (surface, (-i , 0))
 # печатаем картинку со смещением влево
 pygame.display.flip ()
 # отрисовка на дисплее
 #----------------------------
 
surface = pygame.image.load (os.path.join (katalog, risunok))
# грузим картинку
for i in range (0,ys+10,10):
 
 screen.fill ((0, 0, 0))
 # заливаем экран черным
 screen.blit (surface, (0 , i))
 # печатаем картинку со смещением вниз
 pygame.display.flip ()
 # отрисовка на дисплее
 #----------------------------
 
surface = pygame.image.load (os.path.join (katalog, risunok))
# грузим картинку
for i in range (0,ys+10,10):
 
 screen.fill ((0, 0, 0))
 # заливаем экран черным
 screen.blit (surface, (0 , -i))
 # печатаем картинку со смещением вниз
 pygame.display.flip ()
  # отрисовка на дисплее
 #----------------------------

